// $Id: SDLOutputSurface.hh,v 1.2 2005/11/19 15:32:59 m9710797 Exp $

#ifndef SDLOUTPUTSURFACE_HH
#define SDLOUTPUTSURFACE_HH

#include "OutputSurface.hh"

namespace openmsx {

class SDLOutputSurface : public OutputSurface
{
public:
	SDLOutputSurface(unsigned width, unsigned height, bool fullscreen);

	virtual bool init();
	virtual void drawFrameBuffer();
	virtual void finish();

	virtual void takeScreenShot(const std::string& filename);

	virtual std::auto_ptr<Layer> createSnowLayer();
	virtual std::auto_ptr<Layer> createConsoleLayer(
		MSXMotherBoard& motherboard);
	virtual std::auto_ptr<Layer> createIconLayer(
		CommandController& commandController,
		Display& display, IconStatus& iconStatus);
};

} // namespace openmsx

#endif
